Attribute VB_Name = "Process"
'VAR declaration
Dim FF As Byte
Dim CurVal As Byte
Dim CurInt As Integer

Sub ControlInput(Text As TextBox, MaxVal As Integer)
 If val(Text.Text) > MaxVal Then Text.Text = MaxVal
 If val(Text.Text) < 0 Then Text.Text = 0
End Sub

Public Sub OpenState(Filename)

With frmEditor
If Filename = "" Then Exit Sub

Screen.MousePointer = vbHourglass

FF = FreeFile

Open Filename For Binary As #FF

' Character stuff, stats & a little extra stuff
' I recommend you to comment every single I/O
' operation, that helps a lot when debugging
' updating or fixing.

' Be sure to add 1 to every offset you have
' Remember that visual basic open files starting
' from 1 and most hex editors start from 0

' Max Stamina
Get #FF, 5418 + 1, CurVal
.txtStaR = CurVal

' Current Stamina
Get #FF, 5419 + 1, CurVal
.txtStaL = CurVal

' Item #1
Get #FF, 5428 + 1, CurVal
 If CurVal > 26 Then
  .cboItem1.Text = "Unknown"
 Else
  .cboItem1.ListIndex = CurVal
 End If
 
' Item #2
Get #FF, 5430 + 1, CurVal
 If CurVal > 26 Then
  .cboItem2.Text = "Unknown"
 Else
  .cboItem2.ListIndex = CurVal
 End If


' Cows Owned
Get #FF, 76573 + 1, CurVal
.txtCow = CurVal

' Chickens owned
Get #FF, 76574 + 1, CurVal
.txtChick = CurVal

' Wood
Get #FF, 76575 + 1, CurInt
.txtWood = gInt(CurInt)

' Food
Get #FF, 76579 + 1, CurInt
.txtFood = gInt(CurInt)

' Season
Get #FF, 76588 + 1, CurVal
If CurVal > 3 Then
 .cboSeason.Text = "Unknown"
Else
 .cboSeason.ListIndex = CurVal
End If

' Maria Love
Get #FF, 76594 + 1, CurInt
.txtMLove = gInt(CurInt)

' Ann Love
Get #FF, 76596 + 1, CurInt
.txtALove = gInt(CurInt)

' Nina Love
Get #FF, 76598 + 1, CurInt
.txtNLove = gInt(CurInt)

' Ellen Love
Get #FF, 76600 + 1, CurInt
.txtELove = gInt(CurInt)

' Eva Love
Get #FF, 76602 + 1, CurInt
.txtEvaLove = gInt(CurInt)

' Happiness
Get #FF, 76614 + 1, CurInt
.txtHappy = gInt(CurInt)

' Development Rate
Get #FF, 76616 + 1, CurVal
.txtDevRate = CurVal

' Flowers in "secret" garden
Get #FF, 76617 + 1, CurVal
.txtFlowers = CurVal

' Corn Shipped
Get #FF, 76637 + 1, CurInt
.txtCorn = gInt(CurInt)

' Tomatoes Shipped
Get #FF, 76639 + 1, CurInt
.txtTomat = gInt(CurInt)

' Turnips Shipped
Get #FF, 76641 + 1, CurInt
.txtTurnips = gInt(CurInt)

' Potatoes Shipped
Get #FF, 76643 + 1, CurInt
.txtPotato = gInt(CurInt)

' Houses size
Get #FF, 76663 + 1, CurVal
 Select Case CurVal
  Case 0
   .cboHouse.ListIndex = 0
  Case 64
  .cboHouse.ListIndex = 1
  Case 128
  .cboHouse.ListIndex = 2
 End Select
 
Close #FF

Screen.MousePointer = vbDefault
End With

End Sub
Public Sub SaveState(Filename)

With frmEditor
If Filename = "" Then Exit Sub

Screen.MousePointer = vbHourglass

FF = FreeFile

Open Filename For Binary As #FF

' This block is uncommented
' Use val to avoid errors, as well as C[Type]
' CByte, CInt, Clng , etc.

temp = val(.txtStaR.Text)
If temp <= 100 Then
 temp = 100
ElseIf (temp > 100) And (temp < 200) Then
 temp = 200
End If

Put #FF, 5418 + 1, CByte(temp)
Put #FF, 5419 + 1, CByte(val(.txtStaL))
Put #FF, 5428 + 1, CByte(val(Left(.cboItem1.Text, 2)))
Put #FF, 5430 + 1, CByte(val(Left(.cboItem2.Text, 2)))
Put #FF, 76573 + 1, CByte(val(.txtCow))
Put #FF, 76574 + 1, CByte(val(.txtChick))
Put #FF, 76588 + 1, CByte(val(Left(.cboSeason.Text, 1) - 1))
Put #FF, 76616 + 1, CByte(val(.txtDevRate))
Put #FF, 76617 + 1, CByte(val(.txtFlowers))
If .cmdCow.Caption = "ON" Then
 Put #FF, 76653 + 1, CByte(34)
End If
If .cmdClock.Caption = "ON" Then
 Put #FF, 76674 + 1, CByte(64)
End If
If .cboHouse.ListIndex <> -1 Then
 Select Case .cboHouse.ListIndex
  Case 0: temp = 0
  Case 1: temp = 64
  Case 2: temp = 128
 End Select
 Put #FF, 76663 + 1, CByte(temp)
End If

If .chkMoney.value = 1 Then
 Put #FF, 76567 + 1, CInt(16959)
 Put #FF, 76567 + 3, CByte(15)
 Put #FF, 76570 + 1, CInt(16959)
 Put #FF, 76570 + 3, CByte(15)
End If

Close #FF

' This part is for the TWO and THREE bytes var
Call SaveInt(76575 + 1, val(.txtWood), Filename)
Call SaveInt(76579 + 1, val(.txtFood), Filename)

' Loves
Call SaveInt(76594 + 1, val(.txtMLove), Filename)
Call SaveInt(76596 + 1, val(.txtALove), Filename)
Call SaveInt(76598 + 1, val(.txtNLove), Filename)
Call SaveInt(76600 + 1, val(.txtELove), Filename)
Call SaveInt(76602 + 1, val(.txtEvaLove), Filename)

Call SaveInt(76614 + 1, val(.txtHappy), Filename)

Call SaveInt(76637 + 1, val(.txtCorn), Filename)
Call SaveInt(76639 + 1, val(.txtTomat), Filename)
Call SaveInt(76641 + 1, val(.txtTurnips), Filename)
Call SaveInt(76643 + 1, val(.txtPotato), Filename)

Screen.MousePointer = vbDefault
End With

Call OpenState(Filename)

End Sub

'-------------------------------------------------'
' Copyright Che Weng                              '
' The following three functions were developed by '
' Che. http://che.darkmazda.com                   '
' Thanks a lot man!                               '
'-------------------------------------------------'

Public Sub SaveInt(offset, value, location)
    Dim Sval As Byte
    Dim A, B, C
    A = Hex(value)
    If Len(A) = 1 Then A = "000" & A
    If Len(A) = 2 Then A = "00" & A
    If Len(A) = 3 Then A = "0" & A
    
    B = ConvertHex(Left(A, 2))
    C = ConvertHex(Right(A, 2))
    Open location For Binary As 1
        Put #1, offset, CByte(C)
        Put #1, offset - -1, CByte(B)
    Close 1
End Sub
Function ConvertHex(h$) As Currency
    Dim Tmp$
    Dim Lo1 As Integer, Lo2 As Integer
    Dim Hi1 As Long, hi2 As Long
    Const Hx = "&H"
    Const BigShift = 65536
    Const LilShift = 256, Two = 2
    Tmp = h
    'In case "&H" is present
    If UCase(Left$(h, 2)) = "&H" Then Tmp = Mid$(h, 3)
    'In case there are too few characters
    Tmp = Right$("0000000" & Tmp, 8)
    'In case it wasn't a valid number
    If IsNumeric(Hx & Tmp) Then
        Lo1 = CInt(Hx & Right$(Tmp, Two))
        Hi1 = CLng(Hx & Mid$(Tmp, 5, Two))
        Lo2 = CInt(Hx & Mid$(Tmp, 3, Two))
        hi2 = CLng(Hx & Left$(Tmp, Two))
        ConvertHex = CCur(hi2 * LilShift + Lo2) * BigShift + (Hi1 * LilShift) + Lo1
    End If
End Function

Public Function gInt(value)
    Dim A$
    A$ = Hex(value)
    If Len(A$) = 1 Then A$ = "000" & A$
    If Len(A$) = 2 Then A$ = "00" & A$
    If Len(A$) = 3 Then A$ = "0" & A$
    gInt = ConvertHex(A$)
End Function
